window.Gleam.initSearch([{"doc":"geny","title":"geny","content":"# geny\n\n(WIP.)\n\n[![Package Version](https://img.shields.io/hexpm/v/geny)](https://hex.pm/packages/geny)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/geny/)\n\nInspired by rust&#39;s [anyhow](https://github.com/dtolnay/anyhow)  \n\n\n```sh\ngleam add geny\n```\n\n```gleam\nimport geny.{type GResult}\nimport geny.ext.ensure\n\npub fn user_allowed(user_id: Int) -&gt; GResult(String, String) {\n  use &lt;- ensure(must: user_id == 0, error: &quot;Only user 0 is allowed&quot;)\n  // ...\n  // ...\n  // ...\n  Ok(&quot;Good&quot;)\n}\n\nuser_allowed(0) |&gt; should.be_ok\nuser_allowed(1) |&gt; should.be_error\nuser_allowed(2) |&gt; should.be_error\n```\n\nYou could add context for `GResult` and print them:  \n\n```gleam\nimport geny.{type GResult}\nimport geny/ext.{context, from, to_string}\nimport gleam/io\n\nlet result = Error(&quot;This is a error&quot;) |&gt; from  //  &lt;-- This convert/wrap normal `Result` into `GResult`  \nlet result = result |&gt; context(&quot;The context A&quot;)\nlet result = result |&gt; context(&quot;The context B&quot;)\nlet result = result |&gt; context(&quot;The context C&quot;)\n\ncase result {\n  Ok(_) -&gt; io.println(&quot;Good ok!&quot;)\n  Error(geny) -&gt; io.println(geny |&gt; to_string)\n}\n```\n\nThe output is:  \n\n```gleam\nerror: This is a error\n\ncaused by:\n  0: The context A\n  1: The context B\n  2: The context C\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/geny&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n","url":"index.html"},{"doc":"geny","title":"GResult","content":"pub type GResult(a, e) =\n  Result(a, Geny(e))\n\n\nSynonyms:\ngeny.GResult\ngeny GResult","url":"geny.html#GResult"},{"doc":"geny","title":"Geny","content":"pub type Geny(e) {\n  Geny(error: e, contexts: List(String))\n}\n\nGeny(error: e, contexts: List(String))\n\n\nSynonyms:\ngeny.Geny\ngeny Geny","url":"geny.html#Geny"},{"doc":"geny","title":"all","content":"pub fn all(\n  results: List(Result(a, Geny(b))),\n) -&gt; Result(List(a), Geny(b))\n\nSynonyms:\ngeny.all\ngeny all","url":"geny.html#all"},{"doc":"geny","title":"flatten","content":"pub fn flatten(\n  result: Result(Result(a, Geny(b)), Geny(b)),\n) -&gt; Result(a, Geny(b))\n\nSynonyms:\ngeny.flatten\ngeny flatten","url":"geny.html#flatten"},{"doc":"geny","title":"get_error","content":"pub fn get_error(geny: Geny(a)) -&gt; a\n\nSynonyms:\ngeny.get_error\ngeny get_error","url":"geny.html#get_error"},{"doc":"geny","title":"is_error","content":"pub fn is_error(result: Result(a, Geny(b))) -&gt; Bool\n\nSynonyms:\ngeny.is_error\ngeny is_error","url":"geny.html#is_error"},{"doc":"geny","title":"is_ok","content":"pub fn is_ok(result: Result(a, Geny(b))) -&gt; Bool\n\nSynonyms:\ngeny.is_ok\ngeny is_ok","url":"geny.html#is_ok"},{"doc":"geny","title":"lazy_or","content":"pub fn lazy_or(\n  first: Result(a, Geny(b)),\n  second: fn() -&gt; Result(a, Geny(b)),\n) -&gt; Result(a, Geny(b))\n\nSynonyms:\ngeny.lazy_or\ngeny lazy_or","url":"geny.html#lazy_or"},{"doc":"geny","title":"lazy_unwrap","content":"pub fn lazy_unwrap(\n  result: Result(a, Geny(b)),\n  or default: fn() -&gt; a,\n) -&gt; a\n\nSynonyms:\ngeny.lazy_unwrap\ngeny lazy_unwrap","url":"geny.html#lazy_unwrap"},{"doc":"geny","title":"map","content":"pub fn map(\n  over result: Result(a, Geny(b)),\n  with fun: fn(a) -&gt; c,\n) -&gt; Result(c, Geny(b))\n\nSynonyms:\ngeny.map\ngeny map","url":"geny.html#map"},{"doc":"geny","title":"map_error","content":"pub fn map_error(\n  over result: Result(a, Geny(b)),\n  with fun: fn(b) -&gt; c,\n) -&gt; Result(a, Geny(c))\n\nSynonyms:\ngeny.map_error\ngeny map_error","url":"geny.html#map_error"},{"doc":"geny","title":"nil_error","content":"pub fn nil_error(\n  result: Result(a, Geny(b)),\n) -&gt; Result(a, Geny(Nil))\n\nSynonyms:\ngeny.nil_error\ngeny nil_error","url":"geny.html#nil_error"},{"doc":"geny","title":"or","content":"pub fn or(\n  first: Result(a, Geny(b)),\n  second: Result(a, Geny(b)),\n) -&gt; Result(a, Geny(b))\n\nSynonyms:\ngeny.or\ngeny or","url":"geny.html#or"},{"doc":"geny","title":"then","content":"pub fn then(\n  result: Result(a, Geny(b)),\n  apply fun: fn(a) -&gt; Result(c, Geny(b)),\n) -&gt; Result(c, Geny(b))\n\nSynonyms:\ngeny.then\ngeny then","url":"geny.html#then"},{"doc":"geny","title":"to_normal","content":"pub fn to_normal(result: Result(a, Geny(b))) -&gt; Result(a, b)\n\nSynonyms:\ngeny.to_normal\ngeny to_normal","url":"geny.html#to_normal"},{"doc":"geny","title":"try","content":"pub fn try(\n  result: Result(a, Geny(b)),\n  apply fun: fn(a) -&gt; Result(c, Geny(b)),\n) -&gt; Result(c, Geny(b))\n\nSynonyms:\ngeny.try\ngeny try","url":"geny.html#try"},{"doc":"geny","title":"unwrap","content":"pub fn unwrap(result: Result(a, Geny(b)), or default: a) -&gt; a\n\nSynonyms:\ngeny.unwrap\ngeny unwrap","url":"geny.html#unwrap"},{"doc":"geny","title":"unwrap_both","content":"pub fn unwrap_both(result: Result(a, Geny(a))) -&gt; a\n\nSynonyms:\ngeny.unwrap_both\ngeny unwrap_both","url":"geny.html#unwrap_both"},{"doc":"geny","title":"unwrap_error","content":"pub fn unwrap_error(\n  result: Result(a, Geny(b)),\n  or default: b,\n) -&gt; b\n\nSynonyms:\ngeny.unwrap_error\ngeny unwrap_error","url":"geny.html#unwrap_error"},{"doc":"geny","title":"geny","content":"","url":"geny.html"},{"doc":"ext","title":"context","content":"pub fn context(\n  result: Result(a, Geny(b)),\n  context: String,\n) -&gt; Result(a, Geny(b))\n\nSynonyms:\next.context\next context","url":"ext.html#context"},{"doc":"ext","title":"debug","content":"pub fn debug(result: Result(a, Geny(b))) -&gt; Result(a, Geny(b))\n\nSynonyms:\next.debug\next debug","url":"ext.html#debug"},{"doc":"ext","title":"ensure","content":"pub fn ensure(\n  must must: Bool,\n  error error: a,\n  otherwise otherwise: fn() -&gt; Result(b, Geny(a)),\n) -&gt; Result(b, Geny(a))\n\nSynonyms:\next.ensure\next ensure","url":"ext.html#ensure"},{"doc":"ext","title":"from","content":"pub fn from(result: Result(a, b)) -&gt; Result(a, Geny(b))\n\nSynonyms:\next.from\next from","url":"ext.html#from"},{"doc":"ext","title":"lazy_context","content":"pub fn lazy_context(\n  result: Result(a, Geny(b)),\n  context: fn() -&gt; String,\n) -&gt; Result(a, Geny(b))\n\nSynonyms:\next.lazy_context\next lazy_context","url":"ext.html#lazy_context"},{"doc":"ext","title":"to_string","content":"pub fn to_string(geny: Geny(a)) -&gt; String\n\nSynonyms:\next.to_string\next to_string","url":"ext.html#to_string"},{"doc":"ext","title":"wrap_error","content":"pub fn wrap_error(error: a) -&gt; Geny(a)\n\nSynonyms:\next.wrap_error\next wrap_error","url":"ext.html#wrap_error"},{"doc":"ext","title":"ext","content":"","url":"ext.html"}]);